#include <windows.h>

#ifdef __cpluplus
extern "C" {
#endif

#define VMU_VERSION "0.1"

extern HINSTANCE hInstance;
extern HWND      DreamHWnd;
extern HMENU     DreamMenu;
extern WNDCLASS  WndClass;
extern HACCEL    hAccelTable;
extern HDC       SkinDevice;
extern HRGN      ScreenRegion;

extern DWORD     SkinResource;

/* DreamVMU application functions */
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK  DlgProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK  DebugProc(HWND, UINT, WPARAM, LPARAM);
BOOL DreamVMUInit(HINSTANCE hInst, int nCmdShow);
VOID DreamVMUExit();

/* DreamVMU skin related functions */
HRGN ScanRegion(HBITMAP pBitmap, BYTE jTranspR, BYTE jTranspG, BYTE jTranspB);
BYTE* Get24BitPixels(HBITMAP pBitmap, WORD *pwWidth, WORD *pwHeight);

/* DreamVMU menu related functions */
VOID GenerateMenu();

/* DreamVMU File I/O functions */
int GetVmsName();
int GetBiosName();

/* General use functions */
VOID ShowMessage(const char *Text, ...);

#ifdef __cpluplus
extern };
#endif