#include <windows.h>
#include "resource.h"
#include "DreamVMU.h"

/*---------------------*/
/* Generate popup menu */
/*---------------------*/
VOID GenerateMenu()
{
  /* Top menus */
  HMENU Load;
	HMENU Options;

  /* Sub menus */
  HMENU Skins;
  HMENU Color;
  
  /* Sub menus */
  UINT Flags;
  int i;

  /* Destroy menu resources */
  DestroyMenu(DreamMenu);

  /* Create a new popup menu */
  DreamMenu = CreatePopupMenu();
  
  Load    = CreatePopupMenu();
  Options = CreatePopupMenu();

  Skins   = CreatePopupMenu();
  Color   = CreatePopupMenu();
  
  /* Build Main Menu */
  Flags = MF_BYPOSITION | MF_POPUP | MF_STRING;
  i = 0;

  InsertMenu(DreamMenu, i++, MF_BYPOSITION | MF_STRING, IDM_HELP_ABOUT, "&About DreamVMU...");
  InsertMenu(DreamMenu, i++, MF_SEPARATOR , NULL, NULL);
  InsertMenu(DreamMenu, i++, Flags, (UINT)Load,     "&Load");
  InsertMenu(DreamMenu, i++, Flags, (UINT)Options,  "&Options");
  InsertMenu(DreamMenu, i++, MF_SEPARATOR , NULL, NULL);
  InsertMenu(DreamMenu, i++, MF_BYPOSITION | MF_STRING, IDM_FILE_EXIT,  "E&xit");

  Flags = MF_BYPOSITION | MF_STRING;

  /* Build Load Menu */
  i = 0;
  InsertMenu(Load, i++, Flags, IDM_LOAD_VMS, "Load VMS");
  InsertMenu(Load, i++, Flags, IDM_LOAD_BIOS,"Load Bios");

  /* Build Options Menu */
  i = 0;
  InsertMenu(Options, i++, Flags | MF_POPUP, (UINT)Skins, "&Skins");
  InsertMenu(Options, i++, Flags | MF_POPUP, (UINT)Color, "&Colors");
  InsertMenu(Options, i++, MF_SEPARATOR , NULL, NULL);
  InsertMenu(Options, i++, Flags, IDM_OPTIONS_DEBUG, "&Debugger");


  /* Build Options->Skins Menu */
  i = 0;
  InsertMenu(Skins, i++, Flags | (SkinResource == IDB_VMUSKIN_1 ? MF_CHECKED : MF_UNCHECKED), IDM_SKINS_1, "Gerrie's");
  InsertMenu(Skins, i++, Flags | (SkinResource == IDB_VMUSKIN_2 ? MF_CHECKED : MF_UNCHECKED), IDM_SKINS_2, "Evil Red");

  /* Build Options->Color Menu */
  i = 0;
  InsertMenu(Color, i++, Flags , IDM_COLOR_FG, "&Foreground Color");
  InsertMenu(Color, i++, Flags , IDM_COLOR_BG, "&Background Color");

  SetMenu(DreamHWnd, NULL);
}